//********************************************************************************
//
// Central basic types definition - just includes the stock core library types
// for maintainability.
//
// Original author: Rob Baker.
// Current maintainer: Rob Baker.
//
//********************************************************************************

#pragma once
#pragma managed(push,off)


//********************************************************************************
// The basic types.
//********************************************************************************

typedef bool Bool;

typedef float F32;
typedef double F64;

typedef char C8;
typedef wchar_t C16;
typedef unsigned char U8;
typedef signed char S8;
typedef unsigned short U16;
typedef signed short S16;
typedef unsigned int U32;
typedef signed int S32;

static_assert(sizeof(C16) == 2, "C16 should be 2 bytes in size");
static_assert(sizeof(S32) == 4, "S32 should be 4 bytes in size");

#if defined(_MSC_VER)

#include "xmmintrin.h"

namespace libtypes
{
	typedef unsigned __int64 U64;
	typedef __int64 S64;
	typedef __m128 U128;
	typedef __m128 S128;

	static_assert(sizeof(S32) == 4, "S64 should be 8 bytes in size");
}

#endif // defined(_MSC_VER)

#pragma managed(pop)
