//********************************************************************************
//
// Configuration settings for the maths library.
//
// Original author: Rob Baker.
// Current maintainer: Rob Baker.
//
//********************************************************************************

#pragma once


//********************************************************************************
// Some general options are defined here.
//********************************************************************************

// Define LIBMATHS_NAMESPACE_OPEN to 1 if you want to have the libmaths
// namespace open all of the time.
#define LIBMATHS_NAMESPACE_OPEN 0

// Define LIBMATHS_GENERIC to 1 if you want to have no platform-specific code.
// So no platform-specific code if we're using 64-bit or SSE architecture.
#if defined(_M_X64) || _M_IX86_FP >= 1
#define LIBMATHS_GENERIC 1
#else
#define LIBMATHS_GENERIC 0
#endif

// Default to row major matrices where appropriate. Otherwise use the
// column major format.
#define LIBMATHS_ROW_MAJOR_MATRICES 1
#define LIBMATHS_COLUMN_MAJOR_MATRICES 0


//********************************************************************************
// Configure the maths library according to the configuration options.
//********************************************************************************

#if LIBMATHS_NAMESPACE_OPEN
namespace libmaths {}
using namespace libmaths;
#endif // LIBMATHS_NAMESPACE_OPEN
