//********************************************************************************
//
// Polar coordinates representing a 2D vector.
// Consists of a radius from the origin and an azimuth angle from the +X axis.
//
// http://en.wikipedia.org/wiki/Polar_coordinates
//
// Original author: Rob Baker.
// Current maintainer: Rob Baker.
//
//********************************************************************************

#pragma once
#pragma managed(push,off)


//********************************************************************************
// Assignment from a Vector2, in right-hand coordinate system.
//********************************************************************************

LIBMATHS_INLINE Polar2& Polar2::operator = (const Vector2& rhs)
{
	_radius = rhs.Length();
	_azimuth = Atan2(rhs.Y(), rhs.X());

	return (*this);
}


//********************************************************************************
// Normalise this coordinate returning its length.
//********************************************************************************

LIBMATHS_INLINE F32 Polar2::Normalise(void)
{
	F32 length = _radius;

	_radius = 1.0f;

	return length;
}

#pragma managed(pop)
