//********************************************************************************
//
// Spherical coordinates representing a 3D vector.
// Consists of a radius from the origin, a inclination angle from the +Y axis and
// an azimuth angle from the +X axis.
//
// http://en.wikipedia.org/wiki/Spherical_coordinates
//
// Original author: Rob Baker.
// Current maintainer: Rob Baker.
//
//********************************************************************************

#pragma once
#pragma managed(push,off)


//********************************************************************************
// Assignment from a Vector3x, in left-hand coordinate system.
//********************************************************************************

LIBMATHS_INLINE Spherical3LH& Spherical3LH::operator = (const Vector3x& rhs)
{
	_radius = rhs.Length();
	_inclination = Acos(rhs.Y() / _radius);
	_azimuth = Atan2(rhs.Z(), rhs.X());

	return *this;
}


//********************************************************************************
// Assignment from a Vector3, in left-hand coordinate system.
//********************************************************************************

LIBMATHS_INLINE Spherical3LH& Spherical3LH::operator = (const Vector3& rhs)
{
	_radius = rhs.Length();
	_inclination = Acos(rhs.Y() / _radius);
	_azimuth = Atan2(rhs.Z(), rhs.X());

	return *this;
}

#pragma managed(pop)
