//********************************************************************************
//
// 2D vector class.
// Often used for 2D work in screen coordinates and also for texture coordinates.
//
// Original author: Rob Baker.
// Current maintainer: Rob Baker.
//
//********************************************************************************


//********************************************************************************
// Include the required header files.
//********************************************************************************

#include "vector2.h"
#include "polar2.h"


namespace libmaths
{

	//********************************************************************************
	// Assignment from a polar coordinate, resulting in a right-handed vector.
	//********************************************************************************

	Vector2& Vector2::operator = (const Polar2& rhs)
	{
		F32 ca, sa;

		CosSin(rhs.Azimuth(), ca, sa);

		x = rhs.Radius() * ca;
		y = rhs.Radius() * sa;

		return *this;
	}

// namespace libmaths
}