//********************************************************************************
//
// 4D vector class.
// Used in homogenous 4 component vector work.
//
// Original author: Rob Baker.
// Current maintainer: Rob Baker.
//
//********************************************************************************


//********************************************************************************
// Include the required header files.
//********************************************************************************

#include "vector4.h"
#include "matrix44.h"


namespace libmaths
{

	//********************************************************************************
	// Get a new vector from this vector multiplied (transformed) by a quaternion.
	//********************************************************************************

	Vector4 Vector4::operator * (const Quaternion& rhs) const
	{
		return Vector4(Matrix44(rhs) * (*this));
	}


	//********************************************************************************
	// Multiply (transform) this vector by a quaternion.
	//********************************************************************************

	Vector4& Vector4::operator *= (const Quaternion& rhs)
	{
		(*this) *= Matrix44(rhs);

		return *this;
	}

// namespace libmaths
}
